# 🐉 무현코드 공식 문서 v1.0

## 🧾 개요

> **무현코드**는 한국어 기반의 감성 프로그래밍 언어입니다.  
> 블랙코미디, 풍자, 정치적 상징을 담아 만든 패러디 언어로, 파이썬의 거의 모든 기능을 한국어와 밈 기반으로 재해석합니다.

---

## 🛠️ 기본 문법 대응

| 무현 문법 | 파이썬 대응 | 설명 |
|-----------|--------------|------|
| `운지 변수는 값` | `변수 = 값` | 변수 선언 |
| `무현정수 변수 = 값` | `변수 = int(값)` | 정수형 변환 |
| `무현실수 변수 = 값` | `변수 = float(값)` | 실수형 변환 |
| `무현문자열 변수 = 값` | `변수 = str(값)` | 문자열 변환 |
| `무현불리언 변수 = 값` | `변수 = bool(값)` | 불리언 변환 |
| `부엉이바위 "텍스트"` | `print("텍스트")` | 일반 출력 |
| `이기야 "텍스트"` | `print("🔥 " + "텍스트")` | 강조 출력 |

---

## 🌀 흐름 제어

| 무현 문법 | 파이썬 대응 |
|-------------|--------------|
| `중력 조건` | `if 조건:` |
| `운지` | 블록 종료 (`dedent`) |
| `노빠꾸 조건` | `while 조건:` |
| `아메리카노 N번` | `for _ in range(N):` |
| `무현예외` + `무현실패:` | `try:` + `except:` |
| `무현탈출` | `break` |
| `무현넘김` | `continue` |

---

## 📦 함수와 클래스

| 무현 문법 | 파이썬 대응 |
|-------------|-------------|
| `노무 함수명` | `def 함수명():` |
| `노숙자` | `return` |
| `소환해 함수명` | `함수명()` |
| `무현클래스 클래스명` | `class 클래스명:` |
| `무현데이터클래스 클래스명` | `@dataclass class 클래스명:` |
| `무현속성 객체.속성 = 값` | `객체.속성 = 값` |
| `무현호출 객체.메서드()` | `객체.메서드()` |

---

## 🔮 고급 기능

| 무현 문법 | 파이썬 대응 |
|-------------|-------------|
| `무현비동기 함수명` | `async def 함수명():` |
| `무현기다림 표현식` | `await 표현식` |
| `무현컨텍스트 with 표현식:` | `with 표현식:` |
| `무현비산출 값` | `yield 값` |
| `무현글로벌 변수명` | `global 변수명` |
| `무현논로컬 변수명` | `nonlocal 변수명` |
| `무현주입` | `if __name__ == "__main__":` |

---

## 🧩 패턴 매칭

| 무현 문법 | 파이썬 대응 |
|-------------|-------------|
| `무현패턴매칭 변수:` | `match 변수:` |
| `무현케이스 값:` | `case 값:` |

---

## 📚 I/O

| 무현 문법 | 파이썬 대응 |
|-------------|-------------|
| `듣보잡 변수` | `변수 = input()` |
| `무현출력 변수` | `print(변수)` |
| `무현인증 변수` | `print(repr(변수))` |

---

## 🔧 모듈/번역/주석

| 무현 문법 | 파이썬 대응 |
|-------------|-------------|
| `무현불러오기 모듈` | `import 모듈` |
| `무현에서불러오기 모듈에서 항목` | `from 모듈 import 항목` |
| `무현번역해("a.mh", "a.py")` | `.mh` → `.py` 변환 |
| `무현주석 # 텍스트` | `# 텍스트` |

---

## 💥 이스터에그

| 무현 문법 | 효과 |
|-------------|-------|
| `노무현 사 시리즈` | `"노무현은 살아있다"` 출력 |

---

## 🧪 샘플 코드

```mh
듣보잡 입력1
듣보잡 입력2
무현정수 수1 = 입력1
무현정수 수2 = 입력2
무현산술 합계 = 수1 + 수2
부엉이바위 "합계는:"
무현출력 합계
```
